package com.bcxin.tenant.open.dubbo.reader.providers.impls;

import com.bcxin.tenant.open.document.domains.documents.RdExamSiteDocument;
import com.bcxin.tenant.open.document.domains.documents.RdExamSiteDocument$;
import com.bcxin.tenant.open.infrastructures.utils.StringUtil;
import com.bcxin.tenant.open.jdks.ExamSiteReaderRpcProvider;
import com.bcxin.tenant.open.jdks.responses.ExamSiteResponse;
import com.redis.om.spring.search.stream.EntityStream;
import com.redis.om.spring.search.stream.SearchStream;
import org.apache.dubbo.config.annotation.DubboService;

@DubboService
public class ExamSiteReaderRpcProviderImpl implements ExamSiteReaderRpcProvider {
    private final EntityStream entityStream;

    public ExamSiteReaderRpcProviderImpl(EntityStream entityStream) {
        this.entityStream = entityStream;
    }

    @Override
    public ExamSiteResponse get(String id) {
        if(StringUtil.isEmpty(id)) {
            return null;
        }

        SearchStream<RdExamSiteDocument> examSiteDocumentSearchStream =
                this.entityStream.of(RdExamSiteDocument.class);
        examSiteDocumentSearchStream =
                examSiteDocumentSearchStream.filter(RdExamSiteDocument$.ID.eq(id));

        RdExamSiteDocument document
                = examSiteDocumentSearchStream.findFirst().orElse(null);
        if (document == null) {
            return null;
        }

        return ExamSiteResponse.create(document.getId(), document.getName(), document.getAddress(),
                document.getOrganizationId(),
                document.getCompanyName(),
                document.getCountOfRoom(),
                document.getCapacityOfPerson(),
                document.getRegion(),
                document.getLonLat().getY(),
                document.getLonLat().getX()
        );
    }
}
